<?xml version="1.0"?><doc>
<members>
<member name="T:Jacobi.Vst.Interop.Host.VstAudioBufferManager" decl="false" source="c:\workspace\soundengine\vst.net\code\jacobi.vst.interop\host\vstaudiobuffermanager.h" line="10">
<summary>
The VstAudioBufferManager class manages one continues block of unmanaged memory
to service a number of audio buffers.
</summary>
<remarks>The class is instantiated specifying the number and size of buffers that 
can be accessed using the <see cref="M:Jacobi.Vst.Interop.Host.VstAudioBufferManager.ToArray"/> method. The life time of the 
unmanaged memory that backs up the buffers is coupled to the life time of the
VstAudioBufferManager instance. Calling the <see cref="M:Jacobi.Vst.Interop.Host.VstAudioBufferManager.Dispose"/> method will free
the unmanaged memory.</remarks>
</member>
<member name="M:Jacobi.Vst.Interop.Host.VstAudioBufferManager.#ctor(System.Int32,System.Int32)" decl="true" source="c:\workspace\soundengine\vst.net\code\jacobi.vst.interop\host\vstaudiobuffermanager.h" line="23">
<summary>Constructs a new instance for the specified number and size of buffers.</summary>
<param name="bufferCount">The number of buffers.</param>
<param name="bufferSize">The size of a single buffer.</param>
</member>
<member name="M:Jacobi.Vst.Interop.Host.VstAudioBufferManager.Dispose" decl="true" source="c:\workspace\soundengine\vst.net\code\jacobi.vst.interop\host\vstaudiobuffermanager.h" line="27">
<summary>Disposes the instance and free's the unmanaged memory.</summary>
</member>
<member name="M:Jacobi.Vst.Interop.Host.VstAudioBufferManager.ToArray" decl="true" source="c:\workspace\soundengine\vst.net\code\jacobi.vst.interop\host\vstaudiobuffermanager.h" line="30">
<summary>Retrieves the buffers objects, one for each buffer.</summary>
<returns>Returns an array of <see cref="T:Jacobi.Vst.Core.VstAudioBuffer"/> instances.</returns>
</member>
<member name="M:Jacobi.Vst.Interop.Host.VstAudioBufferManager.ClearBuffer(Jacobi.Vst.Core.VstAudioBuffer)" decl="true" source="c:\workspace\soundengine\vst.net\code\jacobi.vst.interop\host\vstaudiobuffermanager.h" line="34">
<summary>Clears (set all values to 0.0) a single buffer.</summary>
<param name="buffer">The buffer to be cleared. Must not be null.</param>
</member>
<member name="M:Jacobi.Vst.Interop.Host.VstAudioBufferManager.ClearAllBuffers" decl="true" source="c:\workspace\soundengine\vst.net\code\jacobi.vst.interop\host\vstaudiobuffermanager.h" line="37">
<summary>Clears all buffers this instance manages.</summary>
</member>
<member name="P:Jacobi.Vst.Interop.Host.VstAudioBufferManager.BufferCount" decl="false" source="c:\workspace\soundengine\vst.net\code\jacobi.vst.interop\host\vstaudiobuffermanager.h" line="40">
<summary>Gets the number of buffers.</summary>
</member>
<member name="P:Jacobi.Vst.Interop.Host.VstAudioBufferManager.BufferSize" decl="false" source="c:\workspace\soundengine\vst.net\code\jacobi.vst.interop\host\vstaudiobuffermanager.h" line="42">
<summary>Gets the size of a single buffer.</summary>
</member>
</members>
</doc>