<?xml version="1.0"?><doc>
<members>
<member name="T:Jacobi.Vst.Interop.Host.VstAudioPrecisionBufferManager" decl="false" source="c:\workspace\soundengine\vst.net\code\jacobi.vst.interop\host\vstaudioprecisionbuffermanager.h" line="11">
<summary>
The VstAudioPrecisionBufferManager class manages one continues block of unmanaged memory
to service a number of audio buffers.
</summary>
<remarks>The class is instantiated specifying the number and size of buffers that 
can be accessed using the <see cref="M:Jacobi.Vst.Interop.Host.VstAudioPrecisionBufferManager.ToArray"/> method. The life time of the 
unmanaged memory that backs up the buffers is coupled to the life time of the
VstAudioPrecisionBufferManager instance. Calling the <see cref="M:Jacobi.Vst.Interop.Host.VstAudioPrecisionBufferManager.Dispose"/> method will free
the unmanaged memory.</remarks>
</member>
<member name="M:Jacobi.Vst.Interop.Host.VstAudioPrecisionBufferManager.#ctor(System.Int32,System.Int32)" decl="true" source="c:\workspace\soundengine\vst.net\code\jacobi.vst.interop\host\vstaudioprecisionbuffermanager.h" line="24">
<summary>Constructs a new instance for the specified number and size of buffers.</summary>
<param name="bufferCount">The number of buffers.</param>
<param name="bufferSize">The size of a single buffer.</param>
</member>
<member name="M:Jacobi.Vst.Interop.Host.VstAudioPrecisionBufferManager.Dispose" decl="true" source="c:\workspace\soundengine\vst.net\code\jacobi.vst.interop\host\vstaudioprecisionbuffermanager.h" line="28">
<summary>Disposes the instance and free's the unmanaged memory.</summary>
</member>
<member name="M:Jacobi.Vst.Interop.Host.VstAudioPrecisionBufferManager.ToArray" decl="true" source="c:\workspace\soundengine\vst.net\code\jacobi.vst.interop\host\vstaudioprecisionbuffermanager.h" line="31">
<summary>Retrieves the buffers objects, one for each buffer.</summary>
<returns>Returns an array of <see cref="T:Jacobi.Vst.Core.VstAudioPrecisionBuffer"/> instances.</returns>
</member>
<member name="M:Jacobi.Vst.Interop.Host.VstAudioPrecisionBufferManager.ClearBuffer(Jacobi.Vst.Core.VstAudioPrecisionBuffer)" decl="true" source="c:\workspace\soundengine\vst.net\code\jacobi.vst.interop\host\vstaudioprecisionbuffermanager.h" line="35">
<summary>Clears (set all values to 0.0) a single buffer.</summary>
<param name="buffer">The buffer to be cleared. Must not be null.</param>
</member>
<member name="M:Jacobi.Vst.Interop.Host.VstAudioPrecisionBufferManager.ClearAllBuffers" decl="true" source="c:\workspace\soundengine\vst.net\code\jacobi.vst.interop\host\vstaudioprecisionbuffermanager.h" line="38">
<summary>Clears all buffers this instance manages.</summary>
</member>
<member name="P:Jacobi.Vst.Interop.Host.VstAudioPrecisionBufferManager.BufferCount" decl="false" source="c:\workspace\soundengine\vst.net\code\jacobi.vst.interop\host\vstaudioprecisionbuffermanager.h" line="41">
<summary>Gets the number of buffers.</summary>
</member>
<member name="P:Jacobi.Vst.Interop.Host.VstAudioPrecisionBufferManager.BufferSize" decl="false" source="c:\workspace\soundengine\vst.net\code\jacobi.vst.interop\host\vstaudioprecisionbuffermanager.h" line="43">
<summary>Gets the size of a single buffer.</summary>
</member>
</members>
</doc>